var apiCloud;

var hotlineBarcodesPicker;
var hotlineNumber = '4008100504';
var bindTelArray = [];

var maintenancePrefsKey = 'maintenanceBarcodes';

var webServiceKey = '1234';


$(function () {
    apiCloud = myAPIClient;


    $$(document).on('pageInit', function (e) {
        var page = e.detail.page;
        if (page.name == 'DeviceMaintenance') {
            $$('#btn_scanner_DeviceMaintenance').on('click', deviceMaintenance_btnScannerHandle);
            $$('#btn_search_DeviceMaintenance').on('click', deviceMaintenance_btnSearchHandle);
            $$('#btn_openselect_DeviceMaintenance').on('click', deviceMaintenance_btnOpenPickerHandle);
        } else if (page.name == 'DeviceMaintenanceResult') {
            deviceMaintenanceResult_init(e);
        } 

    });

    $$(document).on('pageBeforeRemove', function (e) {
        var page = e.detail.page;
        if (page.name == 'DeviceMaintenance') {
            $$('#btn_scanner_DeviceMaintenance').off('click', deviceMaintenance_btnScannerHandle);
            $$('#btn_search_DeviceMaintenance').off('click', deviceMaintenance_btnSearchHandle);
            $$('#btn_openselect_DeviceMaintenance').off('click', deviceMaintenance_btnOpenPickerHandle);

            closePickerModel();
        } else if (page.name == 'DeviceMaintenanceResult') {

        }
    });
});

/**btn callback**/
function deviceMaintenance_btnScannerHandle() {
    myAPIClient.openScanner(function (ret) {
        if (ret.eventType == 'success' && ret.content != null && ret.content != '') {
            $$('#txt_scanner_DeviceMaintenance').val(ret.content);
            saveArrayPrefs(maintenancePrefsKey, ret.content);

            //myApp.getCurrentView().router.loadPage('DeviceMaintenanceResult.html?barCode=' + ret.content);
			
			loadPage('DeviceMaintenanceResult.html?barCode=' + ret.content);
        }
    }, function (err) {
        myApp.alert('扫描失败');
    });
}

function deviceMaintenance_btnSearchHandle() {
    closePickerModel();
    var barcode = $$('#txt_scanner_DeviceMaintenance').val();

    if (barcode == null || barcode == '') {
        myApp.alert('请输入条码');
        return;
    }
    saveArrayPrefs(maintenancePrefsKey, barcode);
    loadPage('DeviceMaintenanceResult.html?barCode=' + barcode);
}

function deviceMaintenance_btnOpenPickerHandle() {
    createPickerModel(maintenancePrefsKey, '#txt_scanner_DeviceMaintenance');
}

/**page init**/
function deviceMaintenance_init() {
    try {
        var barcodes = myAPIClient.getPrefs(maintenancePrefsKey);
        if (barcodes != null && barcodes != '') {
            hotlineBarcodesPicker = createPicker('#txt_scanner_DeviceMaintenance', barcodes.split(","));
        }
    } catch (err) { }
}

function deviceMaintenanceResult_init(e) {
    var barcode = e.detail.page.query["barCode"];
    $$('#txt_barcode').html(barcode);
    myApp.showIndicator();

    myAjax({
        url: 'http://iworkapp.h3c.com:8080/Default/QueryBarcode',
        data: { barCode: barcode },
        method: 'POST',
        cache: false,
        dataType: 'json'
    }, function (data) {
        try {
            if (data == null) {
                $$('#panel_error').show();
                $$('#panel_content').hide();
            } else {
                $$('#panel_error').hide();
                $$('#panel_content').show();


                $$('#txt_startTime').html(data.ServiceStart.split(' ')[0]);
                $$('#txt_endTime').html(data.ServiceEnd.split(' ')[0]);
            }
        } catch (e) { }
        finally {
            myApp.hideIndicator();
        }

    }, function (err) {
        Notify('条码错误');
        myApp.hideIndicator();
    });
}

/**private method**/
function saveArrayPrefs(key, barcode) {
    try {
        var maxLength = 10;
        var barcodes = myAPIClient.getPrefs(key);

        if (barcode == '') return;

        if (barcodes == null || barcodes == '') {
            myAPIClient.setPrefs(key, barcode);
        } else {
            var array = barcodes.split(",");
            if (barcodes.indexOf(barcode) != -1) {
                return;
            } else {
                if (array.length >= maxLength) {
                    array = array.reverse();
                    array.pop();
                    array = array.reverse();
                }

                array.push(barcode);

                myAPIClient.setPrefs(key, array.join(","));
            }
        }
    } catch (err) { }
}

function createPicker(container, values) {
    return myApp.picker({
        input: container,
        rotateEffect: true,
        cols: [
            {
                textAlign: 'left',
                values: values
            }
        ]
    });
}

function createPickerModel(prefsKey, input) {
    var barcodes = myAPIClient.getPrefs(prefsKey);

    if (barcodes == null || barcodes == '') {
        myApp.pickerModal(
            '<div class="picker-modal">' +
              '<div class="toolbar">' +
                '<div class="toolbar-inner">' +
                  '<div class="left"></div>' +
                  '<div class="right"><a href="#" class="close-picker">关闭</a></div>' +
                '</div>' +
              '</div>' +
              '<div class="picker-modal-inner bg-white" style="overflow:auto">' +
                '<div class="content-block">' +
                  '<p>无历史记录</p>' +
                '</div>' +
              '</div>' +
            '</div>'
          );
    } else {
        var liList = '';
        var array = barcodes.split(",");

        for (var i = 0; i < array.length; i++) {
            liList += '<li class="swipeout" data-value="barcode">' +
                        '<div class="swipeout-content item-content">' +
                            '<div class="item-inner" onclick="pickBarcode(this)" data-barcode="' + array[i] + '" data-input="' + input + '">' + array[i] + '</div>' +
                        '</div>' +
                        '<div class="swipeout-actions-right">' +
                            '<a href="#" class="bg-red"  onclick="deleteBarcode(this)" data-prefskey="' + prefsKey + '" data-barcode="' + array[i] + '">删除</a>' +
                        '</div>' +
                    '</li>';
        }


        myApp.pickerModal(
            '<div class="picker-modal">' +
              '<div class="toolbar">' +
                '<div class="toolbar-inner">' +
                  '<div class="left">提示：向左滑动删除</div>' +
                  '<div class="right"><a href="#" class="close-picker">关闭</a></div>' +
                '</div>' +
              '</div>' +
              '<div class="picker-modal-inner bg-white" style="overflow:auto">' +
                '<div class="list-block" style="margin:0px;padding:0px;">' +
                    '<ul>' + liList + '</ul>' +
                '</div>' +
              '</div>' +
            '</div>'
          );
    }
}

function pickBarcode(obj) {
    var barcode = $$(obj).data('barcode');
    var input = $$(obj).data('input');
    $$(input).val(barcode);
    closePickerModel();
}

function deleteBarcode(obj) {
    var prefskey = $$(obj).data('prefskey');
    var barcode = $$(obj).data('barcode');
    var barcodes = myAPIClient.getPrefs(prefskey);

    var array = barcodes.split(",");

    var newArray = [];

    for (var i = 0 ; i < array.length; i++) {
        if (array[i] == barcode) {
            continue;
        }

        newArray.push(array[i]);
    }

    myAPIClient.setPrefs(prefskey, newArray.join(","));

    closePickerModel();
}

function closePickerModel() {
    myApp.closeModal('.picker-modal');
}
