﻿var rootTemplate;
var childTemplate;
var productTemplate;
var noresultTemplate;
var historyKeys = [];
var KEYS_NUM = 9;
$(function () {
    rootTemplate = Template7.compile($$('script#catalogRoot_template').html());
    childTemplate = Template7.compile($$('script#catalogChild_template').html());
    productTemplate = Template7.compile($$('script#productItem_template').html());
    noresultTemplate = Template7.compile($$('script#noResult_template').html());
    if (localStorage.historySearchKeys != undefined) {
        historyKeys = JSON.parse(localStorage.historySearchKeys);
    }
    $$(document).on('pageInit', function (e) {
        var page = e.detail.page;
        $$('.navbar').show();

        if (page.name == 'ProductCatalogue') {
            catalogueInit(e);
        } else if (page.name == 'ProductList') {
            productListInit(e);
        } else if (page.name == "ProductSearch") {
            showHistoryKeys();
        }
    });

    $$(document).on('pageBeforeAnimation', function (e) {
        var page = e.detail.page;
    });

    $$(document).on('pageAfterAnimation', function (e) {
        var page = e.detail.page;
        if (page.name == "ProductSearch") {
            $('#txtSearchArea').focus();
        }
    });

    $$(document).on('pageBeforeRemove', function (e) {
        var page = e.detail.page;
        if (page.name == 'ProductCatalogue') {

        } else if (page.name == 'ProductList') {

        }
    });
});

/***ajax methods***/
function catalogueInit(e) {
    var catalogPanel = $$('#catalogPanel ul');
    catalogPanel.html('');

    myApp.showIndicator();
    myAjax({
        url: serverURL + '/Product/GetCatalogListByPID',
        data: { PID: 'root' },
        method: 'POST',
        cache: false,
        dataType: 'json'
    }, function (data) {
        try {
            $$.each(data, function (index, value) {
                var children = '';
                $$.each(value.children, function (i, v) {
                    children += childTemplate({
                        CatalogName: v.CatalogName,
                        CatalogId: v.CatalogId
                    });
                });

                catalogPanel.append(rootTemplate({
                    RootName: value.rootName,
                    Children: children
                }))
            });
        } catch (e) { }
        finally {
            myApp.hideIndicator();
        }

    }, function (err) {
        Notify('获取数据失败');
        myApp.hideIndicator();
    });
}


function productListInit(e) {
    var catalogName = e.detail.page.query["CatalogName"];
    var catalogId = e.detail.page.query["CatalogId"];

    $$('#txt_title').html(catalogName);

    var productPanel = $$('#productPanel ul');
    var noresultPanel = $$('#noResult');
    productPanel.html('');

    myApp.showIndicator();
    myAjax({
        url: serverURL + '/Product/GetProductListByPID',
        data: { PID: catalogId },
        method: 'POST',
        cache: false,
        dataType: 'json'
    }, function (data) {
        try {
            if (data == null || data.length == 0) {
                noresultPanel.show();
                productPanel.hide();

            } else {
                noresultPanel.hide();
                productPanel.show();

                $$.each(data, function (index, value) {
                    productPanel.append(productTemplate({
                        CatalogId: value.CatalogId,
                        ProductImage: serverURL + value.ProductImage,
                        ProductName: value.ProductName
                    }));
                });
            }
        } catch (e) { }
        finally {
            myApp.hideIndicator();
        }

    }, function (err) {
        Notify('获取数据失败');
        myApp.hideIndicator();
    });
}

function directToProductList(catalogId, catalogName) {
    loadPage('/Product/ProductList?CatalogId=' + catalogId + '&CatalogName=' + catalogName);
}

function directToProuductDetail(catalogId) {
    loadPage('/Product/ProductDetail?CatalogId=' + catalogId);
}

function directToProductSearch() {
    loadPage('/Product/ProductSearch');
}
function cancelSearch() {
    $$('#searchBarProductList ul').html("");
    $$('#searchBarProductList').hide();
    myApp.getCurrentView().router.back();
}
function searchFieldChangeEvent() {
    if ($.trim($('#txtSearchArea').val()) == "") {
        showHistoryKeys();
        return;
    }
    insertHistoryKeys();
    //获取推荐搜索的产品列表
    var params = {
        url: serverURL + '/Product/GetProductListByKey',
        method: 'post',
        data: { key: $('#txtSearchArea').val() },
        dataType: 'json'
    };
    myApp.showIndicator();
    myAjax(params, function (data) {
        try {
            if (data != null) {

                var html = "";
                if (data.length <= 0) {
                    $$('#noResultBlock').show();
                    $$('#searchBarProductList').hide();
                } else {
                    html = Template7.templates.SearchedProductTemplate(data);
                    $$('#searchBarProductList ul').html(html);
                    $$('#searchBarProductList').show();
                    $$('#noResultBlock').hide();
                }

                $$('#historyKeys').hide();
            }
        } catch (e) { }
        finally {
            myApp.hideIndicator();
        }

    }, function (err) {
        Notify('获取数据失败');
        myApp.hideIndicator();
    });
}
function getHistoryIndex(key) {
    var index = -1;
    for (var i = 0; i < historyKeys.length; i++) {
        if (historyKeys[i] == $.trim(key)) {
            index = i;
            break;
        }
    }
    return index;
}
//记录搜索关键字
function insertHistoryKeys() {
    var searchKey = $.trim($('#txtSearchArea').val());
    //如果没超过最大记录限制，9个
    if (historyKeys.length < KEYS_NUM) {
        var index = getHistoryIndex(searchKey);
        //如果已在历史记录中
        if (index >= 0 && index < historyKeys.length) {
            historyKeys.splice(index, 1);
        }
        historyKeys.push(searchKey);
        localStorage.historySearchKeys = JSON.stringify(historyKeys);
    } else {
        var index = getHistoryIndex(searchKey);
        //如果已在历史记录中
        if (index >= 0 && index < historyKeys.length) {
            historyKeys.splice(index, 1);
        } else {
            historyKeys.shift();
        }
        historyKeys.push(searchKey);
        localStorage.historySearchKeys = JSON.stringify(historyKeys);
    }
}
function hideHistoryKeys() {
    $('#historyKeys').hide();
}
function showHistoryKeys() {
    $('#searchBarProductList').hide();
    $$('#noResultBlock').hide();
    var html = '<div >' +
                         '<div style="display:inline-block">历史搜索</div>' +
                         '<a href="#" style="display: inline-block;float: right;" onclick="clearHistory()"><img src="Content/images/button/delete.png" style="width:20px;height:20px;"></a>' +
                     '</div>';
    if (historyKeys.length <= 0) {
        $('#historyKeys').hide();
    } else {
        for (var i = 0; i < historyKeys.length; i++) {
            if (i % 3 == 0) {
                html += '<div class="theme-gray" style="margin-top:10px;">';
            }
            html += Template7.templates.HistoryKeysTemplate({ key: historyKeys[i] });
            if (i % 3 == 2) {
                html += '</div>';
            }
        }
        if (i == historyKeys.length && i % 3 != 0) {
            html += '</div>';
        }
        $('#historyKeys').html(html);
        $('#historyKeys').show();
        $$('.btnHistoryKey').each(function (index, item) {
            $$(item).on('click', function () {
                $('#txtSearchArea').val(historyKeys[index]);
                $('#historyKeys').hide();
                searchFieldChangeEvent();

            });
        });
    }
}
function clearHistory() {
    myApp.confirm("确定清除所有历史记录？", '分销易查通', function () {
        localStorage.historySearchKeys = "";
        historyKeys = [];
        showHistoryKeys();
    }, function () { });
}