﻿
function apiBase() {

}

/**api cloud 接口**/
function apiCloudClient() {
    var FNScanner;
    var touchID;
    var androidScreenLock;
    var mam;
    var push;
    var wx;
    var weibo;
    var contacts;

    var appKey = '52396130-AF4C-E220-7ECE-7F20EEF95966';

    var client = this;

    var isReady = false;

    client.init = function () {
        apiready = function () {
            api.addEventListener({
                name: 'keyback'
            }, function (ret, err) {
                keyBackCallBack();
            });
            api.clearCache(function () { });
            FNScanner = api.require('FNScanner');
            touchID = api.require('touchID');
            androidScreenLock = api.require('screenLock');
            mam = api.require('mam');
            push = api.require('push');
            wx = api.require('wx');
            weibo = api.require('weibo');
            contacts = api.require('contacts');
            var header = document.getElementsByClassName('page-content');
            //适配iOS7+，Android4.4+状态栏沉浸式效果，详见config文档statusBarAppearance字段
            $api.fixStatusBar(header);
            api.setStatusBarStyle({
                style: 'light',
                color: '#FFFFFF'
            });

            isReady = true;
            //api.removeLaunchView();
        }
    };

    /**设备基础信息**/
    client.appId = function () { return api.appId; }
    client.appName = function () { return api.appName; }
    client.appVersion = function () { return api.appVersion; }              //版本号
    client.systemType = function () { return api.systemType; }              //ios or android
    client.systemVersion = function () { return api.systemVersion; }        //手机系统版本号
    client.deviceId = function () { return api.deviceId; }                  //设备唯一标识
    client.deviceToken = function () { return api.deviceToken; }            //ios中用于推送的token
    client.deviceModel = function () { return api.deviceModel; }            //设备型号
    client.deviceName = function () { return api.deviceName; }              //设备名称
    client.operator = function () { return api.operator; }                  //运行商名称
    client.connectionType = function () { return api.connectionType; }      //网络连接类型
    client.screenWidth = function () { return api.screenWidth; }            //屏幕分辨率宽度
    client.screenHeight = function () { return api.screenHeight; }          //屏幕分辨率高度
    client.fsDir = function () { return api.fsDir; }                        //fs://协议对应的真实目录
    client.cacheDir = function () { return api.cacheDir; }                  //cache://协议对应的真实目录

    client.isApiReady = function () { return isReady; }                      //api完成标志

    client.closeWin = function () { api.closeWin(); }
    //弹出一个定时自动关闭的定时框
    client.toast = function (msg, duration) { return api.toast({ msg: msg, duration: duration, location: 'bottom', global: true }); }
    /**打开window**/
    client.openWin = function (title, url) {
        api.openWin({
            name: title,
            url: url,
            pageParam: {
                name: title
            }
        });
    }

    /**打开frame**/
    client.openFrame = function (title, url) {
        api.openFrame({
            name: title,
            url: url,
            rect: {
                x: 0,
                y: 0,
                w: 'auto',
                h: 'auto',
                marginLeft: 0,    //相对父 window 左外边距的距离
                marginTop: 64,    //相对父 window 上外边距的距离
                marginBottom: 0,    //相对父 window 下外边距的距离   //50
                marginRight: 0    //相对父 window 右外边距的距离
            },
            pageParam: {
                name: title
            },
            bounces: true,
            bgColor: '#FFFFFF',
            vScrollBarEnabled: true,
            hScrollBarEnabled: true
        });
    }

    client.closeFrame = function (title) {
        api.closeFrame({
            name: title
        });
    }

    /**跨域异步请求，支持文件上传**/
    client.ajax = function (params, successCallback, errorCallback) {
        api.ajax(params, function (ret, err) {
            if (ret) {
                successCallback(ret);
            } else {
                errorCallback(err);
            }
        });
    }

    /**通过系统相册或拍照获取图片和视频**/
    client.getPicture = function (sourceType, successCallback, errorCallback) {
        api.getPicture({
            sourceType: sourceType,       //library:图片库     camera:相机    album:相册
            //encodingType: 'jpg',        //jpg:指定图片格式为jpg  png:指定图片格式为png  
            mediaValue: 'pic',          //pic:图片   video:视频   all:图片和视频，Android不支持
            destinationType: 'url',     //base64:指定返回数据为base64编码后内容  url:指定返回数据为选取的图片地址
            allowEdit: true,
            quality: 50,
            targetWidth: 600,
            targetHeight: 600,
            saveToPhotoAlbum: false
        }, function (ret, err) {
            if (ret) {
                successCallback(ret);
            } else {
                errorCallback(err);
            }
        });
    }

    /**设置偏好值**/
    client.setPrefs = function (k, v) {
        api.setPrefs({
            key: k,
            value: v
        });
    }

    /**获取偏好值**/
    client.getPrefs = function (k) {
        return api.getPrefs({
            sync: true,
            key: k
        });
    }

    /**删除偏好设置值**/
    client.removePrefs = function (k) {
        api.removePrefs({
            key: k
        });
    }

    /**清除缓存，包括下载的文件、拍照临时文件、网页缓存文件等，清除时可能需要消耗一定时间。**/
    client.clearCache = function (callback) {
        api.clearCache(callback);
    }

    /**拨打电话**/
    client.call = function (phoneNum) {
        api.call({
            type: 'tel_prompt',
            number: phoneNum
        });
    }

    /**选择联系人**/
    client.openContact = function (successCallback, errorCallback) {

        if (api.systemType == 'ios') {
            contacts.select(function (ret, err) {
                if (ret && ret.status) {
                    var phone = ret.phones[0];
                    for (var key in phone) {
                        successCallback(phone[key]);
                        break;
                    }
                } else {
                    errorCallback(err);
                }
            });
        } else {
            api.openContacts(function (ret, err) {
                if (ret && ret.status) {
                    successCallback(ret.phone);
                } else {
                    errorCallback(err);
                }
            });
        }

    }

    /**发送短信**/
    client.sms = function (phoneNum, message, successCallback, errorCallback) {
        api.sms({
            numbers: [phoneNum],
            text: message
        }, function (ret, err) {
            if (ret.status) {
                //已发送
                successCallback(ret);
            } else {
                //发送失败
                errorCallback(err);
            }
        });
    }

    /**设置应用图标右上角数字，支持所有 iOS 手机，以及部分 Android 手机**/
    client.setAppIconBadge = function (num) {
        api.setAppIconBadge({
            badge: num
        });
    }

    /**二维码扫描**/
    client.openScanner = function (successCallback, errorCallback) {
        if (FNScanner != null) {
            FNScanner.openScanner({
                autorotation: true
            }, function (ret, err) {
                if (ret) {
                    successCallback(ret);
                } else {
                    errorCallback(err);
                }
            });
        } else {
            myApp.alert('api not ready');
        }
    }

    /**touchID验证**/
    client.touchIDVerify = function (resultCallback, errorCallback) {
        touchID.verify(
        function (ret, err) {
            if (ret.status) {
                resultCallback(ret);
            } else {
                errorCallback();
            }
        });
    }

    /**android屏幕解锁功能**/
    //设置密码
    client.screenLockSet = function (successCallback, errorCallback) {
        androidScreenLock.set({
            color: '#000000'
        }, function (ret, err) {
            if (ret) {
                successCallback(ret);
            } else {
                errorCallback(err);
            }
        });
    }
    //解锁
    client.screenLockShow = function (successCallback, errorCallback) {
        androidScreenLock.show({
            color: '#000000'
        }, function (ret, err) {
            if (ret) {
                successCallback(ret);
            } else {
                errorCallback(err);
            }
        });
    }

    /**版本检测**/
    client.checkUpdate = function (auto) {
        mam.checkUpdate(function (ret, err) {
            if (ret) {
                var result = ret.result;
                if (result.update == true & result.closed == false) {
                    var str = '新版本型号:' + result.version + ';更新提示语:' + result.updateTip + ';下载地址:' + result.source + ';发布时间:' + result.time;
                    api.confirm({
                        title: '有新的版本,是否下载并安装 ',
                        msg: str,
                        buttons: ['确定', '取消']
                    }, function (ret, err) {
                        if (ret.buttonIndex == 1) {
                            if (api.systemType == "android") {
                                api.download({
                                    url: result.source,
                                    report: true
                                }, function (ret, err) {
                                    if (ret && 0 == ret.state) {/* 下载进度 */
                                        api.toast({
                                            msg: "正在下载应用" + ret.percent + "%",
                                            duration: 2000
                                        });
                                    }
                                    if (ret && 1 == ret.state) {/* 下载完成 */
                                        var savePath = ret.savePath;
                                        api.installApp({
                                            appUri: savePath
                                        });
                                    }
                                });
                            }
                            if (api.systemType == "ios") {
                                api.installApp({
                                    appUri: result.source
                                });
                            }
                        }
                    });
                } else {
                    if (!auto) {
                        api.alert({
                            msg: "暂无更新"
                        });
                    }
                }
            } else {
                if (!auto) {
                    //api.alert({
                    //    msg: err.msg
                    //});
                }
            }
        });
    }

    /**云推送**/
    client.pushMessage = function (title, message, type) {
        var now = Date.now();
        var appKey = $.sha1(client.appId() + "UZ" + appKey + "UZ" + now) + "." + now;

        $$.post('/Home/Push', {
            appId: client.appId(),
            appKey: appKey,
            type: type,
            title: title,
            message: message
        }, function (data) {

        });
    }

    /**wx分享**/
    //判断是否安装了微信
    client.wxIsInstalled = function (successCallback, errorCallback) {
        wx.isInstalled(function (ret, err) {
            if (ret.installed) {
                successCallback(ret);
            } else {
                errorCallback(err);
            }
        });
    }

    //分享文本内容到朋友圈
    client.wxShareText = function (text, successCallback, errorCallback) {
        wx.shareText({
            apiKey: '',
            scene: 'timeline',
            text: text
        }, function (ret, err) {
            if (ret.status) {
                successCallback(ret);
            } else {
                errorCallback(err);
            }
        });
    }

    //分享图片内容到 到 回话 scene = session  朋友圈 scene = timeline
    client.wxShareImage = function (scene, thumb, contentUrl, successCallback, errorCallback) {
        wx.shareImage({
            apiKey: '',
            scene: scene,
            thumb: thumb,
            contentUrl: contentUrl
        }, function (ret, err) {
            if (ret.status) {
                successCallback(ref);
            } else {
                errorCallback(err);
            }
        });
    }

    //分享网络视频资源 到  回话 scene = session  朋友圈 scene = timeline
    client.wxShareVideo = function (scene, title, description, thumb, contentUrl, successCallback, errorCallback) {
        wx.shareVideo({
            apiKey: '',
            scene: scene,
            title: title,
            description: description,
            thumb: thumb,
            contentUrl: contentUrl
        }, function (ret, err) {
            if (ret.status) {
                successCallback(ret);
            } else {
                errorCallback(err);
            }
        });
    }

    //分享网页 到  回话 scene = session  朋友圈 scene = timeline
    client.wxShareWebpage = function (scene, title, description, thumb, contentUrl, successCallback, errorCallback) {
        wx.shareWebpage({
            apiKey: '',
            scene: scene,
            title: title,
            description: description,
            thumb: thumb,
            contentUrl: contentUrl
        }, function (ret, err) {
            if (ret.status) {
                successCallback(ret);
            } else {
                errorCallback(err);
            }
        });
    }

    /**weibo分享**/
    //判断是否安装了微博
    client.weiboIsInstalled = function (successCallback, errorCallback) {
        weibo.isInstalled(
            function (ret) {
                if (ret.status) {
                    successCallback();
                } else {
                    errorCallback();
                }
            }
        );
    }

    //分享文本内容到微博
    client.weiboShareText = function (text, successCallback, errorCallback) {
        weibo.shareText({
            text: text,
        }, function (ret, err) {
            if (ret.status) {
                successCallback(ret);
            } else {
                errorCallback(err);
            }
        });
    }

    //分享图片内容到微博
    client.weiboShareImage = function (title, contentUrl, successCallback, errorCallback) {
        weibo.shareImage({
            text: title,
            imageUrl: contentUrl
        }, function (ret, err) {
            if (ret.status) {
                successCallback(ret);
            } else {
                errorCallback(err);
            }
        });
    }

    //分享网页到微博
    client.weiboShareWebPage = function (text, title, description, thumb, contentUrl, successCallback, errorCallback) {
        weibo.shareWebPage({
            text: text,
            title: title,
            description: description,
            thumb: thumb,
            contentUrl: contentUrl
        }, function (ret, err) {
            if (ret.status) {
                successCallback(ret);
            } else {
                errorCallback(err);
            }
        });
    }

    //绑定推送信息，并监听推送消息
    client.bindPush = function (user, id, bindSuccessCallback, bindErrorCallback, dataCallback) {
        var int = self.setInterval(function () { checkReady() }, 200);
        function checkReady() {
            if (isReady) {
                push.bind({
                    userName: user,
                    userId: id
                }, function (ret, err) {
                    if (ret.status) {
                        //绑定成功
                        bindSuccessCallback(ret);

                        //监听推送消息
                        push.setListener(
                            function (ret, err) {

                                if (ret) {
                                    dataCallback(ret);
                                }
                            }
                        );

                    } else {
                        //绑定失败
                        bindErrorCallback(err);
                    }
                });

                clearInterval(int);
            }
        }
    }

    //清除缓存
    client.clearCache = function (successCallback) {
        api.clearCache(successCallback);
    }

    //获取缓存的大小
    client.getCacheSize = function (successCallback) {
        api.getCacheSize(function (ret) {
            successCallback(ret);
        });
    }

    //添加事件
    client.addEventListener = function (eventNanme, callback) {
        api.addEventListener({
            name: eventNanme
        }, function (ret, err) {
            if (ret) {
                // alert(ret);
                callback();
            } else {

            }
        });
    }
}


apiCloudClient.prototype = new apiBase();

var myAPIClient = new apiCloudClient();
myAPIClient.init();


function fnPlay(url) {
    var videoPlayer = api.require('videoPlayer');
    videoPlayer.play({
        texts: {
            head: {
                title: '返回'
            }
        },
        styles: {
            head: {
                bg: 'rgba(0.5,0.5,0.5,0.7)',
                height: 44,
                titleSize: 25,
                titleColor: '#fff',
                backSize: 25,
                backImg: 'widget://image/back.png',
                setSize: 25,
                setImg: 'widget://image/set.png'
            },
            foot: {
                bg: 'rgba(0.5,0.5,0.5,0.7)',
                height: 44,
                timeColor: '#fff',
                progressColor: '#696969',
                progressSelected: '#76EE00'
            }
        },
        path: url,
        autoPlay: true
    }, function (ret, err) {

    });
}